
module lamp() {
$fn=128;
union() {
difference() {
   union(){
      cylinder(r=75, h=15);
      translate([0,0,10]) cylinder(r=80, h=5); 
   }
   translate([-90,-100,-5])cube([180,100,30]);
   translate([0,0,5]) cylinder(r=65, h=40);
   translate([0,40,-5]) cylinder(r=25, h=20);
   translate([40,10,-5]) cylinder(r=2, h=15);
   translate([40,12,-5]) cylinder(r=2, h=15);
   translate([-40,10,-5]) cylinder(r=2, h=15);
   translate([-40,12,-5]) cylinder(r=2, h=15);
   translate([0,0,7.5]) {
      translate([0,80,0])
         rotate([90,0,0])cylinder(r=1.6, h=30);
   }
}

difference() {
   union() {
      translate([-25,5,0]) cube([50,6,40]);
      translate([0,11,40]) 
          rotate([90,0,0]) cylinder(r=25, h=6);
   }
   translate([0,25,40]) {
      rotate([90,0,0]) {
          //cylinder(r=30, h=120);
          cylinder(r=20, h=40);
      }
   }
 }
 
 } // union
 }
 
 
 
 module lamp_spaceadd()
{
    $fn=128;
    translate([0,25,40]) {
        rotate([90,0,0]) {
              cylinder(r=30, h=100);   
        }
    }
     translate([0,0,7.5]) {
         translate([0,130,0])
            rotate([90,0,0])cylinder(r=1.6, h=60);
    } 
    
}
 
module lamp_space() {
   union() {
      lamp(); 
      lamp_spaceadd(); 
    }
}
 

module lamp_support() {
   $fn=128;
   difference(){
      cylinder(r=85, h=16);
      translate([-95,-100,-5])cube([190,100,30]);
      translate([0,0,-1]) {
         cylinder(r=75.5, h=25);
         translate([0,0,10]) cylinder(r=80, h=6);

      }
      
   }  
    
}

module lamp_nopinsupport() {
   $fn=128;
   difference(){
       lamp_support();
        translate([0,0,-1]) {
            translate([0,0,7.5]) {
                translate([0,90,0])
                   rotate([90,0,0])cylinder(r=1.6, h=50);
            }
        } 
     }
}

module lamp_pinsupport() {
    $fn=128;
    union() {
        lamp_support();
        translate([0,0,-1]) {
            translate([0,0,7.65]) {
                translate([0,84,0])
                   rotate([90,0,0])cylinder(r=1.3, h=14);
            }
        }
    }
}


// solo lampada
// lamp();

// lampada e ingombri
//lamp_space();
   
// supporto
lamp_nopinsupport();

// supporto con pin
 //lamp_pinsupport();
